<template>
  <v-tooltip location="bottom" text="Berechtigung bearbeiten">
    <template v-slot:activator="{ props }">
      <v-btn
        v-bind="props"
        icon="mdi-square-edit-outline"
        density="comfortable"
        variant="text"
        color="success"
        @click="openDialog()"
      ></v-btn>
    </template>
  </v-tooltip>

  <v-dialog v-model="showDialog" max-width="600">
    <v-card prepend-icon="mdi-square-edit-outline" title="Berechtigung bearbeiten">
      <v-card-text>
        <v-row dense>
          <v-col cols="12">
            <v-text-field 
              label="Name:*" 
              v-model="form.name" 
              :rules="formErrors.name"
              :error-messages="nameExistsError ? 'Dieser Name existiert bereits!' : ''"
              @update:modelValue="nameExistsError = false"
              required
            ></v-text-field>
          </v-col>
        </v-row>

        <small class="text-caption text-medium-emphasis">
          *kennzeichnet ein Pflichtfeld
        </small>
      </v-card-text>

      <v-divider></v-divider>

      <v-card-actions>
        <v-spacer></v-spacer>

        <div class="d-flex flex-row justify-space-between w-100">
          <v-btn text="Abbrechen" color="error" @click="showDialog = false"></v-btn>

          <v-btn
            text="Berechtigung speichern"
            color="success"
            :disabled="isFormInvalid()"
            @click="submitForm()"
          ></v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { ref } from "vue";
import { api, RoleRightBody, RoleRightResponse } from "../api";

const props = defineProps<{ roleRight: RoleRightResponse }>();

const emits = defineEmits<{ (event: "submitted"): void }>();

const showDialog = ref<boolean>(false);

const nameExistsError = ref<boolean>(false);

const form = ref<RoleRightBody>({
  name: "",
});

const formErrors = {
  name: [
    (value: string) => {
      if (value?.length === 0) {
        return "Bitte gebe einen Namen an!";
      }
      return true;
    },
  ],
};

function openDialog(): void {
  form.value = {
    name: props.roleRight.name,
  };

  showDialog.value = true;
}

function isFormInvalid(): boolean {
  const { name } = form.value;

  return name.length === 0;
}

function submitForm(): void {
  if (isFormInvalid()) {
    return;
  }
  api.roleRights
    .patchRoleRight(props.roleRight.id, form.value)
    .then(() => {
      emits("submitted");
      showDialog.value = false;
    })
    .catch((error) => {
      if (error?.response?.status === 409) {
        nameExistsError.value = true;
        return;
      }
      console.error(error);
    });
}
</script>
